VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegistryMan"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''''''Programmer:Javad Soltani'''''''''''Last Date Edition:2006/05/28   1385/03/07

Private Type LUID
    lowpart        As Long
    highpart       As Long
End Type
Private Type LUID_AND_ATTRIBUTES
    pLuid          As LUID
    Attributes     As Long
End Type
Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges     As LUID_AND_ATTRIBUTES
End Type

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal HKEY As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpSubKey As String, _
                    ByVal Reserved As Long, _
                    ByVal lpClass As String, _
                    ByVal dwOptions As Long, _
                    ByVal samDesired As Long, _
                    lpSecurityAttributes As Any, _
                    phkResult As Long, _
                    lpdwDisposition As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpValueName As String) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" ( _
                    ByVal HKEY As Long, _
                    ByVal dwIndex As Long, _
                    ByVal lpName As String, _
                    ByVal cbName As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" ( _
                    ByVal HKEY As Long, _
                    ByVal dwIndex As Long, _
                    ByVal lpValueName As String, _
                    lpcbValueName As Long, _
                    ByVal lpReserved As Long, _
                    lpType As Long, _
                    lpData As Any, _
                    lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpSubKey As String, _
                    ByVal ulOptions As Long, _
                    ByVal samDesired As Long, _
                    phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpValueName As String, _
                    ByVal lpReserved As Long, _
                    lpType As Long, _
                    lpData As Any, _
                    lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpValueName As String, _
                    ByVal Reserved As Long, _
                    ByVal dwType As Long, _
                    lpData As Any, _
                    ByVal cbData As Long) As Long
Private Declare Function RegSaveKey Lib "advapi32.dll" Alias "RegSaveKeyA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpFile As String, _
                    lpSecurityAttributes As Any) As Long
Private Declare Function RegRestoreKey Lib "advapi32.dll" Alias "RegRestoreKeyA" ( _
                    ByVal HKEY As Long, _
                    ByVal lpFile As String, _
                    ByVal dwFlags As Long) As Long
Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" ( _
                    ByVal TokenHandle As Long, _
                    ByVal DisableAllPriv As Long, _
                    NewState As TOKEN_PRIVILEGES, _
                    ByVal BufferLength As Long, _
                    PreviousState As TOKEN_PRIVILEGES, _
                    ReturnLength As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" ( _
                    ByVal lpSystemName As Any, _
                    ByVal lpName As String, _
                    lpLuid As LUID) As Long
Private Declare Function OpenProcessToken Lib "advapi32.dll" ( _
                    ByVal ProcessHandle As Long, _
                    ByVal DesiredAccess As Long, _
                    TokenHandle As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" ( _
                    ByVal lpSrc As String, _
                    ByVal lpDst As String, _
                    ByVal nSize As Long) As Long
Private Declare Function SendMessageTimeout Lib "User32" Alias "SendMessageTimeoutA" ( _
                    ByVal hwnd As Long, _
                    ByVal msg As Long, _
                    ByVal wParam As Long, _
                    ByVal lParam As Any, _
                    ByVal fuFlags As Long, _
                    ByVal uTimeout As Long, _
                    lpdwResult As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
                    lpvDest As Any, _
                    lpvSource As Any, _
                    ByVal cbCopy As Long)

Private Const LongForOR               As Long = &H80000000
Private Const Error_SUCCESS           As Long = 0&
'Private Const ERROR_NO_MORE_ITEMS    As Long = 259&
Private Const REG_OPTION_NON_VOLATILE As Long = &H0 ' Specify constants to registry action types.
Private Const KEY_QUERY_VALUE         As Long = &H1
Private Const KEY_SET_VALUE           As Long = &H2
Private Const KEY_CREATE_SUB_KEY      As Long = &H4
Private Const KEY_ENUMERATE_SUB_KEYS  As Long = &H8
Private Const KEY_NOTIFY              As Long = &H10
Private Const KEY_CREATE_LINK         As Long = &H20
Private Const SYNCHRONIZE             As Long = &H100000
Private Const STANDARD_RIGHTS_ALL     As Long = &H1F0000
Private Const KEY_ALL_ACCESS          As Long = ((STANDARD_RIGHTS_ALL Or _
                                                 KEY_QUERY_VALUE Or _
                                                 KEY_SET_VALUE Or _
                                                 KEY_CREATE_SUB_KEY Or _
                                                 KEY_ENUMERATE_SUB_KEYS Or _
                                                 KEY_NOTIFY Or _
                                                 KEY_CREATE_LINK) And _
                                                 (Not SYNCHRONIZE))

Public Enum HKeys
    HKCR = 0 'HKEY_CLASSES_ROOT     = &H80000000
    HKCU     'HKEY_CURRENT_USER     = &H80000001
    HKLM     'HKEY_LOCAL_MACHINE    = &H80000002
    HKU      'HKEY_USERS            = &H80000003
    HKPD     'HKEY_PERFORMANCE_DATA = &H80000004
    HKCC     'HKEY_CURRENT_CONFIG   = &H80000005
    HKDD     'HKEY_DYN_DATA         = &H80000006
End Enum
Public Enum ValueTypes
    regNONE = 0                         ' No value type
    regSz = 1                           ' Unicode nul terminated string
    regEXPAND_SZ = 2                    ' Unicode nul terminated string w/enviornment var
    regBINARY = 3                       ' Free form binary
    regDWORD = 4                        ' 32-bit number
    regDWORD_LITTLE_ENDIAN = 4          ' 32-bit number (same as REG_DWORD)
    regDWORD_BIG_ENDIAN = 5             ' 32-bit number
    regLINK = 6                         ' Symbolic Link (unicode)
    regMULTI_SZ = 7                     ' Multiple Unicode strings
    regRESOURCE_LIST = 8                ' Resource list in the resource map
    regFULL_RESOURCE_DESCRIPTOR = 9     'Resource list in the hardware description
    reg_RESOURCE_REQUIREMENTS_LIST = 10
End Enum

Private pro_MesForProcessOnMainKeys As Boolean
Public Function CreateValue(ByVal HKEY As HKeys, _
                            ByVal SubKey As String, _
                            ByVal ValueName As String, _
                            Optional ByVal ValueType As ValueTypes = regSz, _
                            Optional ByVal ValueData As Variant = "", _
                            Optional ByRef IsNewValue As Boolean _
                            ) As Boolean
Dim OutFu   As Long
Dim Vtype   As Long
         Vtype = ValueType
Dim HKeyIn  As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
         If Not (OutFu = Error_SUCCESS) Then
            CreateValue = False
            GoTo EndProcess
         End If
             
Dim kp_VOldtype As Long, _
    kp_OldData  As String, _
    kp_LOldData As Long 'kp_ Areea Exit than Process
    OutFu = RegQueryValueEx(hNewKey, _
                            ValueName, _
                            ByVal 0&, _
                            kp_VOldtype, _
                            ByVal kp_OldData, _
                            kp_LOldData)
    IsNewValue = Not (OutFu = Error_SUCCESS)

    Select Case ValueType
       
       Case regDWORD, regDWORD_LITTLE_ENDIAN, regDWORD_BIG_ENDIAN:
Dim ValueDataWriteLng As Long
         ValueDataWriteLng = Val(ValueData)
            OutFu = RegSetValueEx(hNewKey, _
                                  ValueName, _
                                  ByVal 0&, _
                                  Vtype, _
                                  ValueDataWriteLng, _
                                  Len(ValueDataWriteLng))
       Case Else:
Dim ValueDataWriteStr As String
         ValueDataWriteStr = ValueData
            OutFu = RegSetValueEx(hNewKey, _
                                  ValueName, _
                                  ByVal 0&, _
                                  Vtype, _
                                  ByVal ValueDataWriteStr, _
                                  Len(ValueDataWriteStr))
    End Select
    
    CreateValue = OutFu = Error_SUCCESS
    
EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
'''1-CreateValue
Public Function CreateKey(ByVal HKEY As HKeys, _
                          ByVal SubKey As String, _
                          Optional ByVal DefaultValueType As ValueTypes = regSz, _
                          Optional ByVal DefaultValueData As Variant = vbNullChar, _
                          Optional ByRef IsNewKey As Boolean _
                          ) As Boolean
Dim OutFu     As Long
Dim hNewKey   As Long
Dim IsNewKeyL As Long
Dim HKeyIn    As Long
         HKeyIn = HKEY Or LongForOR
    
    OutFu = RegCreateKeyEx(HKeyIn, _
                           SubKey, _
                           0&, _
                           regSz, _
                           REG_OPTION_NON_VOLATILE, _
                           KEY_ALL_ACCESS, _
                           ByVal 0&, _
                           hNewKey, _
                           IsNewKeyL)
    
    If Not (DefaultValueType = regSz And DefaultValueData = vbNullChar) Then
Dim LngOut As Boolean
        If CreateValue(HKEY, _
                       SubKey, _
                       Empty, _
                       DefaultValueType, _
                       DefaultValueData) Then
                        OutFu = Error_SUCCESS
        Else
                        OutFu = Error_SUCCESS - 1
        End If
        
    End If
    
    If IsNewKeyL = 1 Then
        IsNewKey = True
    ElseIf IsNewKeyL = 2 Then
        IsNewKey = False
    End If
    
    CreateKey = OutFu = Error_SUCCESS
    
EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
'''1-CorrectValue
Public Function IsValue(ByVal HKEY As HKeys, _
                        ByVal SubKey As String, _
                        ByVal ValueName As String, _
                        Optional ByRef ValueType As ValueTypes, _
                        Optional ByRef ValueData As Variant, _
                        Optional ByRef CorrectValueData As Variant _
                        ) As Boolean
Dim OutFu   As Long
Dim Vtype   As Long
Dim LenData As Long
Dim HKeyIn  As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
         If Not (OutFu = Error_SUCCESS) Then
            IsValue = False
            GoTo EndProcess
         End If
             
Dim kp_OldData  As String, _
    kp_LOldData As Long 'kp_ Areea Exit than Process
    OutFu = RegQueryValueEx(hNewKey, _
                            ValueName, _
                            ByVal 0&, _
                            Vtype, _
                            ByVal kp_OldData, _
                            kp_LOldData)
    
    Select Case Vtype
    
       Case regSz, regBINARY, regEXPAND_SZ, regLINK, regMULTI_SZ, _
            regNONE, regRESOURCE_LIST:
Dim ValueDataGetStr As String
         ValueDataGetStr = String$(2000, vbNullChar)
         LenData = Len(ValueDataGetStr)
            OutFu = RegQueryValueEx(hNewKey, _
                                    ValueName, _
                                    ByVal 0&, _
                                    Vtype, _
                                    ByVal ValueDataGetStr, _
                                    LenData)
            ValueData = Left$(ValueDataGetStr, LenData)
            
       Case Else:
Dim ValueDataGetLng As Long
         ValueDataGetLng = &H0
         LenData = Len(ValueDataGetLng)
            OutFu = RegQueryValueEx(hNewKey, _
                                    ValueName, _
                                    ByVal 0&, _
                                    Vtype, _
                                    ValueDataGetLng, _
                                    LenData)
            ValueData = ValueDataGetLng

    End Select
    
    If OutFu = Error_SUCCESS Then
        ValueType = Vtype
        CorrectValueData = CorrectValue(ValueData, ValueType)
        IsValue = True
    Else
        ValueType = Empty
        ValueData = Empty
        IsValue = False
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Public Function IsKey(ByVal HKEY As HKeys, ByVal SubKey As String) As Boolean
Dim OutFu   As Long
Dim HKeyIn  As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    IsKey = OutFu = Error_SUCCESS

EndProcess:
OutFu = RegCloseKey(hNewKey)
    
End Function
Public Function DeleteReg(ByVal HKEY As HKeys, _
                          ByVal SubKey As String, _
                          Optional ByVal ValueName As String = Empty _
                          ) As Boolean
Dim OutFu   As Long
Dim HKeyIn  As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        DeleteReg = False
        GoTo EndProcess
    End If
    
    'If ValueName = Empty Then
    '    OutFu = RegDeleteKey(hNewKey, _
    '                         Empty) ' Deafult Value Name=Empty
    'Else
        OutFu = RegDeleteValue(hNewKey, ValueName)
    'End If
    
    DeleteReg = OutFu = Error_SUCCESS

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Private Function EmptyValues(ByVal HKeyIn As Long, ByVal SubKey As String) As Boolean
Dim OutFu      As Long
Dim ValueNameI As String, ValueNameIL As Long
Dim IIndexV    As Long
Dim hNewKey    As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        EmptyValues = False
        GoTo EndProcess
    End If
    
Dim kp_VOldtype As Long, _
    kp_OldData  As String, _
    kp_LOldData As Long 'kp_ Areea Exit than Process
    IIndexV = 0
    
    Do
        ValueNameI = String$(2000, vbNullChar)
        ValueNameIL = Len(ValueNameI)
        kp_OldData = String$(2000, vbNullChar)
        kp_LOldData = Len(kp_OldData)
        
        OutFu = RegEnumValue(hNewKey, _
                             IIndexV, _
                             ByVal ValueNameI, _
                             ValueNameIL, _
                             0&, _
                             regDWORD, _
                             ByVal kp_OldData, _
                             kp_LOldData)
        
        OutFu = RegDeleteValue(hNewKey, _
                               Left$(ValueNameI, ValueNameIL))
        
        'IIndexV = IIndexV + 1-1 '''Area Next Remove Value =-1
    Loop While OutFu = Error_SUCCESS
    EmptyValues = True

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Public Function HaveSubKey(ByVal HKEY As HKeys, _
                           ByVal SubKey As String, _
                           Optional ByRef FirstSubKeyName As String, _
                           Optional ByRef NumbersSubKey As Long _
                           ) As Boolean
Dim OutFu    As Long
Dim KeyNameI As String, KeyNameIL As Long
Dim IIndexV  As Long
Dim HKeyIn   As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey  As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        HaveSubKey = False
        GoTo EndProcess
    End If
    
    IIndexV = -1
    
    Do
        KeyNameI = String$(500, vbNullChar)
        KeyNameIL = Len(KeyNameI)
        IIndexV = IIndexV + 1
        
        OutFu = RegEnumKey(hNewKey, _
                           IIndexV, _
                           KeyNameI, _
                           KeyNameIL)
                           
        If IIndexV = 0 Then FirstSubKeyName = Split(KeyNameI, vbNullChar)(0)
    Loop While OutFu = Error_SUCCESS
    
    If IIndexV = 0 Then
        NumbersSubKey = 0
        FirstSubKeyName = Empty
        HaveSubKey = False
    Else
        NumbersSubKey = IIndexV
        HaveSubKey = True
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Private Function HaveSubKeyIn(ByVal HKEY As HKeys, _
                              Optional ByVal SubKey As String, _
                              Optional ByRef NameSubKey As String, _
                              Optional ByVal CodeIndexSubKey As Long = 0 _
                              ) As Boolean
Dim OutFu    As Long
Dim KeyNameI As String, KeyNameIL As Long
Dim hNewKey  As Long
         OutFu = RegOpenKeyEx(HKEY, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        HaveSubKeyIn = False
        GoTo EndProcess
    End If
   
    KeyNameI = String$(500, vbNullChar)
    KeyNameIL = Len(KeyNameI)

    OutFu = RegEnumKey(hNewKey, _
                       CodeIndexSubKey, _
                       KeyNameI, _
                       KeyNameIL)
                       
    NameSubKey = Split(KeyNameI, vbNullChar)(0)
    
    If OutFu = Error_SUCCESS Then
        HaveSubKeyIn = True
    Else
        NameSubKey = Empty
        HaveSubKeyIn = False
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Public Function IsMainKey(ByVal HKEY As HKeys, _
                          ByVal SubKey As String, _
                          Optional ByRef FullKeyStr As String _
                          ) As Boolean
    Select Case HKEY
       Case HKCR: FullKeyStr = "HKEY_CLASSES_ROOT"
       Case HKCU: FullKeyStr = "HKEY_CURRENT_USER"
       Case HKLM: FullKeyStr = "HKEY_LOCAL_MACHINE"
       Case HKU: FullKeyStr = "HKEY_USERS"
       Case HKPD: FullKeyStr = "HKEY_PERFORMANCE_DATA"
       Case HKCC: FullKeyStr = "HKEY_CURRENT_CONFIG"
       Case HKDD: FullKeyStr = "HKEY_DYN_DATA"
    End Select
    
    If Not (SubKey = Empty) Then FullKeyStr = FullKeyStr & ChBackSlash & SubKey
    
    Select Case UCase(FullKeyStr)
        Case UCase("HKEY_CLASSES_ROOT"), _
             UCase("HKEY_CURRENT_USER"), _
             UCase("HKEY_LOCAL_MACHINE"), _
             UCase("HKEY_USERS"), _
             UCase("HKEY_PERFORMANCE_DATA"), _
             UCase("HKEY_CURRENT_CONFIG"), _
             UCase("HKEY_DYN_DATA"), _
             UCase("HKEY_LOCAL_MACHINE\HARDWARE"), _
             UCase("HKEY_LOCAL_MACHINE\SAM"), _
             UCase("HKEY_LOCAL_MACHINE\SECURITY"), _
             UCase("HKEY_LOCAL_MACHINE\SOFTWARE"), _
             UCase("HKEY_LOCAL_MACHINE\SYSTEM"), _
             UCase("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet"), _
             UCase("HKEY_USERS\.DEFAULT"), _
             UCase("HKEY_USERS\S-1-5-18"), _
             UCase("HKEY_USERS\S-1-5-19"), _
             UCase("HKEY_USERS\S-1-5-19_Classes"), _
             UCase("HKEY_USERS\S-1-5-20"), _
             UCase("HKEY_USERS\S-1-5-20_Classes"), _
             UCase("HKEY_CURRENT_CONFIG\Software"), _
             UCase("HKEY_CURRENT_CONFIG\System"):
                IsMainKey = True
        
        Case Else:
                IsMainKey = False

    End Select

End Function
Private Function SubMesMainKeys() As Boolean
Const TitleText As String = "Danger for Change data ..."
    
    If Not pro_MesForProcessOnMainKeys Then
        If MsgBox("this is Main Key and Change that Have Danger !" & vbCrLf _
                & "are you Sure for Run this Command ?", vbYesNo + vbDefaultButton2 + vbQuestion, TitleText) = vbYes Then
                
                If MsgBox("if you Running this Command ,May half your System !" & _
                        vbCrLf & "are you Sure for Run this Command ?", vbYesNo + vbExclamation, _
                        TitleText) = vbYes Then
                
                    SubMesMainKeys = True
                    Exit Function
                End If
                
        End If
    End If
    SubMesMainKeys = False

End Function
'''1-IsValue
Public Function HaveValue(ByVal HKEY As HKeys, _
                          ByVal SubKey As String, _
                          Optional ByRef NumbersValue As Long, _
                          Optional ByRef FirstValueName As String, _
                          Optional ByRef FirstValueType As ValueTypes, _
                          Optional ByRef FirstValueData As Variant _
                          ) As Boolean
Dim OutFu      As Long
Dim ValueNameI As String, ValueNameIL As Long
Dim IIndexV    As Long
Dim HKeyIn     As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey    As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        HaveValue = False
        GoTo EndProcess
    End If
    
    IIndexV = -1
    
Dim kp_VOldtype As Long, _
    kp_OldData  As String, _
    kp_LOldData As Long 'kp_ Areea Exit than Process
    
    Do
        ValueNameI = String$(2000, vbNullChar)
        ValueNameIL = Len(ValueNameI)
        kp_OldData = String$(2000, vbNullChar)
        kp_LOldData = Len(kp_OldData)
        IIndexV = IIndexV + 1
        
        OutFu = RegEnumValue(hNewKey, _
                             IIndexV, _
                             ByVal ValueNameI, _
                             ValueNameIL, _
                             0&, _
                             kp_VOldtype, _
                             ByVal kp_OldData, _
                             kp_LOldData)
       
        If IIndexV = 0 Then
            FirstValueName = Split(ValueNameI, vbNullChar)(0)
            IsValue HKEY, _
                    SubKey, _
                    FirstValueName, _
                    FirstValueType, _
                    FirstValueData
        End If
    Loop While OutFu = Error_SUCCESS
    
    If IIndexV = 0 Then
        NumbersValue = 0
        FirstValueName = Empty
        FirstValueType = 0
        FirstValueData = Empty
        HaveValue = False
    Else
        NumbersValue = IIndexV
        HaveValue = True
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
'''1-EmptyValues,, 2-HaveSubKeyIn,, 3-IsMainKey,, 4-SubMesMainKeys
Public Function EmptyReg(ByVal HKEY As HKeys, _
                         ByVal SubKey As String, _
                         Optional ByVal EmptyValuesKey As Boolean = True, _
                         Optional ByVal EmptyAllSubKeys As Boolean = True, _
                         Optional ByVal OnlyEmptyAllValues As Boolean = False _
                         ) As Boolean
    If IsMainKey(HKEY, SubKey) Then _
        If Not SubMesMainKeys Then Exit Function
    
Dim OutFu      As Long
Dim SubKeyName As String, thisSubKeyName   As String
Dim NumberBS   As Integer, CodeIndexSubKey As Long
Dim HKeyIn     As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey    As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        EmptyReg = False
        GoTo EndProcess
    End If
    
    If EmptyValuesKey Then EmptyValues hNewKey, Empty
    If EmptyAllSubKeys And HaveSubKeyIn(hNewKey, Empty, SubKeyName) Then
ReturnP:
        Do
            thisSubKeyName = thisSubKeyName & ChBackSlash & SubKeyName
            EmptyValues hNewKey, Right(thisSubKeyName, Len(thisSubKeyName) - 1)
        Loop While HaveSubKeyIn(hNewKey, Right(thisSubKeyName, Len(thisSubKeyName) - 1), SubKeyName)
        Do
            If Not OnlyEmptyAllValues Then
                OutFu = RegDeleteKey(hNewKey, _
                                     Right(thisSubKeyName, Len(thisSubKeyName) - 1))
            End If
            NumberBS = UBound(Split(thisSubKeyName, ChBackSlash))
            thisSubKeyName = Split(thisSubKeyName, ChBackSlash)(NumberBS)
        Loop While Not (Len(thisSubKeyName) = 0)
        If OnlyEmptyAllValues Then CodeIndexSubKey = CodeIndexSubKey + 1
        If HaveSubKeyIn(hNewKey, Empty, SubKeyName, CodeIndexSubKey) Then GoTo ReturnP
    End If
    
    EmptyReg = True
    
EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Public Function CorrectValue(ByVal UnCorrectValue As Variant, _
                             ByVal ValueType As ValueTypes _
                             ) As Variant
    
    CorrectValue = UnCorrectValue
    If UnCorrectValue = Empty Then Exit Function
    
    Select Case ValueType
        Case regSz, regEXPAND_SZ:
            If Right(CorrectValue, 1) = vbNullChar Then _
                CorrectValue = Left$(CorrectValue, Len(CorrectValue) - 1)
        Case regMULTI_SZ:
            If Right(CorrectValue, 2) = String$(2, vbNullChar) Then
                CorrectValue = Left$(CorrectValue, Len(CorrectValue) - 2)
            ElseIf Right(CorrectValue, 1) = vbNullChar Then _
                CorrectValue = Left$(CorrectValue, Len(CorrectValue) - 1)
            End If
            CorrectValue = Replace(CorrectValue, vbNullChar, vbCrLf)
        Case regNONE:
            CorrectValue = vbNull
    End Select

End Function
'''1-IsValue ,,, 2-CreateValue
Public Function EditValue(ByVal HKEY As HKeys, _
                          ByVal SubKey As String, _
                          ByVal ValueName As String, _
                          Optional ByVal NewValueName As String = vbNullChar, _
                          Optional ByVal NewValueData As Variant = vbNullChar, _
                          Optional ByVal NewValueType As ValueTypes = -1 _
                          ) As Boolean
Dim OutFu        As Long, OutFuB             As Boolean
Dim OldValueType As ValueTypes, OldValueData As Variant, IsNewValue As Boolean
Dim HKeyIn       As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey      As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
         If Not (OutFu = Error_SUCCESS) Then
            EditValue = False
            GoTo EndProcess
         End If
         
    OutFuB = IsValue(HKEY, _
                     SubKey, _
                     ValueName, _
                     OldValueType, _
                     Empty, _
                     OldValueData)
    If Not OutFuB Then
        EditValue = False
        GoTo EndProcess
    End If
    
    If NewValueName = vbNullChar Then NewValueName = ValueName
    If NewValueType = -1 Then NewValueType = OldValueType
    If NewValueData = vbNullChar Then NewValueData = OldValueData
    
    OutFuB = CreateValue(HKEY, _
                         SubKey, _
                         NewValueName, _
                         NewValueType, _
                         NewValueData, _
                         IsNewValue)
    If Not OutFuB Then
        EditValue = False
        GoTo EndProcess
    Else
        EditValue = True
    End If
    
    If IsNewValue Or (Not StrComp(UCase(ValueName), UCase(NewValueName)) = 0) Then
        OutFu = RegDeleteValue(hNewKey, ValueName)
         EditValue = OutFu = Error_SUCCESS
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
'''1-IsValue ,,,2-CreateValue
Public Function CopyValue(ByVal SourceHKEY As HKeys, _
                          ByVal SourceSubKey As String, _
                          ByVal SourceValueName As String, _
                          Optional ByVal DestinationHKEY As HKeys, _
                          Optional ByVal DestinationSubKey As String = vbNullChar, _
                          Optional ByVal DestinationValueName As String = vbNullChar _
                          ) As Boolean
Dim OutFu     As Long, OutFuB      As Boolean
Dim ValueName As String, ValueType As ValueTypes, ValueData As Variant
Dim HkeyInS   As Long
         HkeyInS = SourceHKEY Or LongForOR
Dim hNewKeyS  As Long
         OutFu = RegOpenKeyEx(HkeyInS, _
                              SourceSubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKeyS)
                              
         If Not (OutFu = Error_SUCCESS) Then
            CopyValue = False
            GoTo EndProcess
         End If

    OutFuB = IsValue(SourceHKEY, _
                     SourceSubKey, _
                     SourceValueName, _
                     ValueType, _
                     ValueData)
    If Not OutFuB Then
        CopyValue = False
        GoTo EndProcess
    End If

    If DestinationHKEY = Empty Then DestinationHKEY = SourceHKEY
    If DestinationSubKey = vbNullChar Then DestinationSubKey = SourceSubKey

Dim HkeyInD  As Long
         HkeyInD = DestinationHKEY Or LongForOR
Dim hNewKeyD As Long
         OutFu = RegOpenKeyEx(HkeyInD, _
                              DestinationSubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKeyD)
                              
         If Not (OutFu = Error_SUCCESS) Then
            OutFu = RegCreateKeyEx(HkeyInD, _
                                   DestinationSubKey, _
                                   0&, _
                                   regSz, _
                                   REG_OPTION_NON_VOLATILE, _
                                   KEY_ALL_ACCESS, _
                                   ByVal 0&, _
                                   hNewKeyD, _
                                   IsNewKeyL)
            If Not (OutFu = Error_SUCCESS) Then
               CopyValue = False
               GoTo EndProcess
            End If
         End If

    If DestinationValueName = vbNullChar Then ValueName = SourceValueName Else ValueName = DestinationValueName

    OutFuB = CreateValue(DestinationHKEY, _
                         DestinationSubKey, _
                         ValueName, _
                         ValueType, _
                         ValueData)
    CopyValue = OutFuB

EndProcess:
OutFu = RegCloseKey(hNewKeyS)
OutFu = RegCloseKey(hNewKeyD)

End Function
'''1-IsValue
Public Function IndexValue(ByVal HKEY As HKeys, _
                           ByVal SubKey As String, _
                           Optional ByVal IndexHave As Long = 1, _
                           Optional ByRef ValueName As String, _
                           Optional ByRef ValueType As ValueTypes, _
                           Optional ByRef ValueData As Variant = "", _
                           Optional ByRef NumbersValue As Long _
                           ) As Boolean
Dim OutFu      As Long
Dim ValueNameI As String, ValueNameIL As Long
Dim IIndexV    As Long
Dim HKeyIn     As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey    As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        IndexValue = False
        GoTo EndProcess
    End If
    
    IIndexV = -1
    
Dim kp_VOldtype As Long, _
    kp_OldData  As String, _
    kp_LOldData As Long 'kp_ Areea Exit than Process
    
    Do
        ValueNameI = String$(2000, vbNullChar)
        ValueNameIL = Len(ValueNameI)
        kp_OldData = String$(2000, vbNullChar)
        kp_LOldData = Len(kp_OldData)
        IIndexV = IIndexV + 1
        
        OutFu = RegEnumValue(hNewKey, _
                             IIndexV, _
                             ByVal ValueNameI, _
                             ValueNameIL, _
                             0&, _
                             kp_VOldtype, _
                             ByVal kp_OldData, _
                             kp_LOldData)
       
        If IIndexV = IndexHave - 1 Then
            ValueName = Split(ValueNameI, vbNullChar)(0)
            IsValue HKEY, _
                    SubKey, _
                    ValueName, _
                    ValueType, _
                    ValueData
        End If
    Loop While OutFu = Error_SUCCESS
    NumbersValue = IIndexV
    
    If IIndexV = 0 Or IndexHave <= 0 Or IndexHave > IIndexV Then
        ValueName = Empty
        ValueType = 0
        ValueData = Empty
        IndexValue = False
    Else
        IndexValue = True
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Public Function IndexSubKey(ByVal HKEY As HKeys, _
                            ByVal SubKey As String, _
                            Optional ByVal IndexHave As Long = 1, _
                            Optional ByRef NameSubKey As String, _
                            Optional ByRef NumbersSubKey As Long _
                            ) As Boolean
Dim OutFu    As Long
Dim KeyNameI As String, KeyNameIL As Long
Dim IIndexV  As Long
Dim HKeyIn   As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey  As Long
         OutFu = RegOpenKeyEx(HKeyIn, _
                              SubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKey)
                              
    If Not (OutFu = Error_SUCCESS) Then
        IndexSubKey = False
        GoTo EndProcess
    End If
    
    IIndexV = -1
    
    Do
        KeyNameI = String$(500, vbNullChar)
        KeyNameIL = Len(KeyNameI)
        IIndexV = IIndexV + 1
        
        OutFu = RegEnumKey(hNewKey, _
                           IIndexV, _
                           KeyNameI, _
                           KeyNameIL)
                           
        If IIndexV = IndexHave - 1 Then NameSubKey = Split(KeyNameI, vbNullChar)(0)
    Loop While OutFu = Error_SUCCESS
    NumbersSubKey = IIndexV
    
    If IIndexV = 0 Or IndexHave <= 0 Or IndexHave > IIndexV Then
        NameSubKey = Empty
        IndexSubKey = False
    Else
        IndexSubKey = True
    End If

EndProcess:
OutFu = RegCloseKey(hNewKey)

End Function
Public Function CopyValues(ByVal SourceHKEY As HKeys, _
                           ByVal SourceSubKey As String, _
                           Optional ByVal DestinationHKEY As HKeys, _
                           Optional ByVal DestinationSubKey As String = vbNullChar _
                           ) As Boolean
Dim OutFu                As Long, OutFuB            As Boolean
Dim DestinationValueName As String, SourceValueName As String
Dim ValueName            As String, ValueType       As ValueTypes, ValueData As Variant
Dim SourceValueNameL     As Long, ValueDataL        As Long, IIndexV         As Long
Dim HkeyInS              As Long
         HkeyInS = SourceHKEY Or LongForOR
Dim hNewKeyS             As Long
         OutFu = RegOpenKeyEx(HkeyInS, _
                              SourceSubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKeyS)
                              
         If Not (OutFu = Error_SUCCESS) Then
            CopyValues = False
            GoTo EndProcess
         End If
         
    If DestinationHKEY = Empty Then DestinationHKEY = SourceHKEY
    If DestinationSubKey = vbNullChar Then DestinationSubKey = SourceSubKey

Dim HkeyInD  As Long
         HkeyInD = DestinationHKEY Or LongForOR
Dim hNewKeyD As Long
         OutFu = RegOpenKeyEx(HkeyInD, _
                              DestinationSubKey, _
                              REG_OPTION_NON_VOLATILE, _
                              KEY_ALL_ACCESS, _
                              hNewKeyD)
                              
         If Not (OutFu = Error_SUCCESS) Then
            OutFu = RegCreateKeyEx(HkeyInD, _
                                   DestinationSubKey, _
                                   0&, _
                                   regSz, _
                                   REG_OPTION_NON_VOLATILE, _
                                   KEY_ALL_ACCESS, _
                                   ByVal 0&, _
                                   hNewKeyD, _
                                   IsNewKeyL)
            If Not (OutFu = Error_SUCCESS) Then
               CopyValues = False
               GoTo EndProcess
            End If
         End If
    
    IIndexV = -1
    
Dim kp_ValueDataStr As String

    Do
        SourceValueName = String$(2000, vbNullChar)
        SourceValueNameL = Len(SourceValueName)
        kp_ValueDataStr = String$(2000, vbNullChar)
        ValueDataL = Len(kp_ValueDataStr)
        IIndexV = IIndexV + 1
        
        OutFu = RegEnumValue(hNewKeyS, _
                             IIndexV, _
                             ByVal SourceValueName, _
                             SourceValueNameL, _
                             ByVal 0&, _
                             regDWORD, _
                             ByVal kp_ValueDataStr, _
                             ValueDataL)
        If Not (OutFu = Error_SUCCESS) Then Exit Do
    
        SourceValueName = Left$(SourceValueName, SourceValueNameL)
        OutFuB = IsValue(SourceHKEY, _
                         SourceSubKey, _
                         SourceValueName, _
                         ValueType, _
                         ValueData)
        If Not OutFuB Then
            CopyValues = False
            GoTo EndProcess
        End If
    
        DestinationValueName = SourceValueName
        OutFuB = CreateValue(DestinationHKEY, _
                             DestinationSubKey, _
                             DestinationValueName, _
                             ValueType, _
                             ValueData)
        If Not OutFuB Then
            CopyValues = False
            GoTo EndProcess
        End If
        
    Loop While OutFu = Error_SUCCESS
    CopyValues = True

EndProcess:
OutFu = RegCloseKey(hNewKeyS)
OutFu = RegCloseKey(hNewKeyD)

End Function
Public Function ExportRegKeyHive(ByVal HKEY As HKeys, _
                                 ByVal SubKey As String, _
                                 ByVal FileNamePath As String _
                                 ) As Boolean
         On Error Resume Next
Const SE_BACKUP_NAME As String = "SeBackupPrivilege"
Dim OutFu            As Long
Dim ValueNameI       As String, ValueNameIL As Long
Dim IIndexV          As Long
Dim HKeyIn           As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey          As Long
         
    If EnablePrivilege(SE_BACKUP_NAME) = False Then
        ExportRegKeyHive = False
        Exit Function
    End If

    OutFu = RegOpenKeyEx(HKeyIn, _
                         SubKey, _
                         0&, _
                         KEY_ALL_ACCESS, _
                         hNewKey)
    If Not OutFu = Error_SUCCESS Then
        ExportRegKeyHive = False
        GoTo EndProcess
    End If
    
    OutFu = RegSaveKey(hNewKey, _
                       FileNamePath, _
                       ByVal 0&)
    
    ExportRegKeyHive = OutFu = Error_SUCCESS
  
EndProcess:
    OutFu = RegCloseKey(hNewKey)

End Function
Public Function ImportRegKeyHive(ByVal HKEY As HKeys, _
                                 ByVal SubKey As String, _
                                 ByVal FileNamePath As String _
                                 ) As Boolean
         On Error Resume Next
Const SE_RESTORE_NAME   As String = "SeRestorePrivilege" 'Important for what we're trying to accomplish
Const REG_FORCE_RESTORE As Long = 8& 'Permission to overwrite a registry key
Dim OutFu               As Long
Dim ValueNameI          As String, ValueNameIL As Long
Dim IIndexV             As Long
Dim HKeyIn              As Long
         HKeyIn = HKEY Or LongForOR
Dim hNewKey             As Long

    If EnablePrivilege(SE_RESTORE_NAME) = False Then
        ImportRegKeyHive = False
        Exit Function
    End If
  
    OutFu = RegOpenKeyEx(HKeyIn, _
                         SubKey, _
                         0&, _
                         KEY_ALL_ACCESS, _
                         hNewKey)
    If Not OutFu = Error_SUCCESS Then
        ImportRegKeyHive = False
        GoTo EndProcess
    End If
  
    OutFu = RegRestoreKey(hNewKey, _
                          FileNamePath, _
                          REG_FORCE_RESTORE)
    
    ImportRegKeyHive = OutFu = Error_SUCCESS
  
EndProcess:
    OutFu = RegCloseKey(hNewKey)

End Function
' routine to enable inport/export of registry settings
Private Function EnablePrivilege(seName As String) As Boolean
         On Error Resume Next
Const TOKEN_QUERY             As Long = &H8&
Const TOKEN_ADJUST_PRIVILEGES As Long = &H20&
Const SE_PRIVILEGE_ENABLED    As Long = &H2
Dim p_lngRtn                  As Long
Dim p_lngToken                As Long
Dim p_lngBufferLen            As Long
Dim p_typLUID                 As LUID
Dim p_typTokenPriv            As TOKEN_PRIVILEGES
Dim p_typPrevTokenPriv        As TOKEN_PRIVILEGES

    p_lngRtn = OpenProcessToken(GetCurrentProcess(), _
                                TOKEN_ADJUST_PRIVILEGES Or _
                                TOKEN_QUERY, _
                                p_lngToken)
    If p_lngRtn = 0 Or (Not Err.LastDllError = Error_SUCCESS) Then
        EnablePrivilege = False
        Exit Function
    End If

    p_lngRtn = LookupPrivilegeValue(0&, _
                                    seName, _
                                    p_typLUID)
    If p_lngRtn = 0 Then
        EnablePrivilege = False
        Exit Function
    End If
  
    p_typTokenPriv.PrivilegeCount = 1
    p_typTokenPriv.Privileges.Attributes = SE_PRIVILEGE_ENABLED
    p_typTokenPriv.Privileges.pLuid = p_typLUID
    
    EnablePrivilege = Not AdjustTokenPrivileges(p_lngToken, _
                                                False, _
                                                p_typTokenPriv, _
                                                Len(p_typPrevTokenPriv), _
                                                p_typPrevTokenPriv, _
                                                p_lngBufferLen) = Error_SUCCESS

End Function
Public Function EXPAND_SZStr(ByVal DataInput As String) As String
Dim lBuffer As Long, GData As String
    
    GData = Empty
    lBuffer = ExpandEnvironmentStrings(DataInput, GData, lBuffer)
    GData = String$(lBuffer, vbNullChar)
    lBuffer = ExpandEnvironmentStrings(DataInput, GData, lBuffer)
    EXPAND_SZStr = Replace(GData, vbNullChar, Empty)

End Function
Public Function PathEXPAND_SZ(ByVal DataInput As String) As String
'Const ChEquals    As String = "="
'Const ChPercent   As String = "%"
Const EnvironFilters = "HOMEPATH USERNAME SESSIONNAME USERDOMAIN PROCESSOR_REVISION PROCESSOR_LEVEL PROCESSOR_IDENTIFIER PROCESSOR_ARCHITECTURE PATHEXT Path OS NUMBER_OF_PROCESSORS LOGONSERVER COMPUTERNAME CLIENTNAME"
Dim EnviroFilter() As String
         EnvironFilter = Split(EnvironFilters, ChSpace)
Dim OutputData     As String
         OutputData = DataInput
Dim reg_Expandsz_M As String
Dim EnvironName    As String
Dim ReplWord       As String
Dim MemoMaxL()     As Integer
         ReDim MemoMaxL(1, 0)

    ISum = 0
    Do
    ISum = ISum + 1
        EnvironName = Split(Environ$(ISum), ChEquals)(0)
        For Each memoA In EnvironFilter
            If StrComp(UCase(EnvironName), memoA) = 0 Then
                reg_Expandsz_M = Empty
                GoTo PoalF
            End If
        Next memoA
            
        reg_Expandsz_M = Right$(Environ$(ISum), Len(Environ$(ISum)) - Len(EnvironName) - 1)
        If Len(reg_Expandsz_M) <= 1 Then reg_Expandsz_M = Empty
PoalF:
        If UBound(MemoMaxL, 2) = 0 Then
            MemoMaxL(0, 0) = Len(reg_Expandsz_M)
            MemoMaxL(1, 0) = ISum
        Else
            For ISumIn = LBound(MemoMaxL, 2) To UBound(MemoMaxL, 2)
                If Len(reg_Expandsz_M) > MemoMaxL(0, ISumIn) Then
                    For ISum3 = UBound(MemoMaxL, 2) To ISumIn Step -1
                        If Not ISum3 = 0 Then
                            MemoMaxL(0, ISum3) = MemoMaxL(0, ISum3 - 1)
                            MemoMaxL(1, ISum3) = MemoMaxL(1, ISum3 - 1)
                        End If
                    Next ISum3
                    MemoMaxL(0, ISumIn) = Len(reg_Expandsz_M)
                    MemoMaxL(1, ISumIn) = ISum
                    Exit For
                ElseIf ISumIn = UBound(MemoMaxL, 2) Then
                    MemoMaxL(0, UBound(MemoMaxL, 2)) = Len(reg_Expandsz_M)
                    MemoMaxL(1, UBound(MemoMaxL, 2)) = ISum
                End If
            Next ISumIn
        End If
        ReDim Preserve MemoMaxL(1, UBound(MemoMaxL, 2) + 1)
    Loop Until Environ$(ISum + 1) = Empty
    ReDim Preserve MemoMaxL(1, UBound(MemoMaxL, 2) - 1)
        
    For ISum = LBound(MemoMaxL, 2) To UBound(MemoMaxL, 2)
        If Not MemoMaxL(0, ISum) = 0 Then
            reg_Expandsz_M = Right(Environ$(MemoMaxL(1, ISum)), Len(Environ$(MemoMaxL(1, ISum))) - Len(Split(Environ$(MemoMaxL(1, ISum)), ChEquals)(0)) - 1)
            If Not (InStr(1, UCase(OutputData), UCase(reg_Expandsz_M)) = 0) Then
                ReplWord = ChPercent & Split(Environ$(MemoMaxL(1, ISum)), ChEquals)(0) & ChPercent
                OutputData = Replace(OutputData, reg_Expandsz_M, ReplWord, , , vbTextCompare)
            End If
        End If
    Next ISum
    
EndProcess: ''''''''
PathEXPAND_SZ = OutputData
    
End Function
Public Sub RefreshSystemObjects()
Const HWND_BROADCAST          As Long = &HFFFF&
Const WM_SETTINGCHANGE        As Long = &H1A
Const SPI_SETNONCLIENTMETRICS As Long = 42
Const SMTO_ABORTIFHUNG        As Long = &H2
Dim Result                    As Long

    Call SendMessageTimeout(HWND_BROADCAST, WM_SETTINGCHANGE, SPI_SETNONCLIENTMETRICS, _
            0&, SMTO_ABORTIFHUNG, 10000&, Result)

End Sub
Public Function SwapEndian(ByVal ValueIn As Long) As Long
    CopyMemory ByVal VarPtr(SwapEndian) + 3, ValueIn, 1
    CopyMemory ByVal VarPtr(SwapEndian) + 2, ByVal VarPtr(ValueIn) + 1, 1
    CopyMemory ByVal VarPtr(SwapEndian) + 1, ByVal VarPtr(ValueIn) + 2, 1
    CopyMemory SwapEndian, ByVal VarPtr(ValueIn) + 3, 1
End Function
Public Property Get MesForProcessOnMainKeys() As Boolean
   MesForProcessOnMainKeys = Not pro_MesForProcessOnMainKeys
End Property
Public Property Let MesForProcessOnMainKeys(ByVal New_Value As Boolean)
    pro_MesForProcessOnMainKeys = Not New_Value
End Property
